// Copyright (C) 2002, 2003, NLnet Labs, All rights reserved.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef PERFORMANCE_HH
#define PERFORMANCE_HH

#include "analyzer.hh"
#include "timer.hh"
#include "variable.hh"

namespace dns_analyzer {

    class performance_listener_type : public listener_type {
    public:
        performance_listener_type();
        virtual ~performance_listener_type();

        virtual void initialize(analyzer_type &analyzer);
        virtual void analyze(analyzer_type &analyzer,
                             timeval const &timestamp,
                             network_packet const &packet);
        virtual void finalize(analyzer_type &analyzer);

    private:
        timer_type _timer;
        size_t _packet_count;
        stat_type _stats;
    };
}

#endif // PERFORMANCE_HH
