// Copyright (C) 2002, 2003, NLnet Labs, All rights reserved.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef R_PROJECT_HH
#define R_PROJECT_HH

#include "analyzer.hh"

namespace dns_analyzer {
    // Listener that exports the packets to a R data file.
    class r_project_listener_type : public listener_type {
    public:
        r_project_listener_type();
        virtual ~r_project_listener_type();

        virtual void initialize(analyzer_type &analyzer);
        virtual void analyze(analyzer_type &analyzer,
                             timeval const &timestamp,
                             network_packet const &packet);
        virtual void finalize(analyzer_type &analyzer);

        void base_filename(string const &value) { _base_filename = value; }
        void split_count(size_t value) { _split_count = value; }

    private:
        string _base_filename;
        size_t _split_count;

        size_t _output_count;
        ofstream _output;

        void open_output();
        void write_output(analyzer_type const &analyzer,
                          timeval const &timestamp,
                          network_packet const &packet);
    };
}

#endif // R_PROJECT_HH
