// Copyright (C) 2002, 2003, NLnet Labs, All rights reserved.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef TIMER_HH
#define TIMER_HH

#include <ostream>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/resource.h>

namespace dns_analyzer {

    using std::ostream;

    class timer_type {
    public:
        timer_type() {}
        ~timer_type() {}

        void start();
        void stop();

        void real_time(timeval &result) const;
        double real_time() const;

        void cpu_time(timeval &result) const;
        double cpu_time() const;

        void user_time(timeval &result) const;
        double user_time() const;

        void sys_time(timeval &result) const;
        double sys_time() const;

        void print(ostream &out);
    private:
        timeval _start_time;
        rusage _start_rusage;
        timeval _stop_time;
        rusage _stop_rusage;
    };
}

#endif /* TIMER_HH */
